# -*- coding: utf-8 -*-
"""Project_4_G5.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1ASL-TOX0ovLSceDqeMIEJj1v8GUT3jAz
"""

! pip install transformers

! pip install pytorch-ignite

import os
import psutil
import torchvision
import ignite
import ignite.contrib.handlers
import ignite.engine
import torch.nn.functional as F
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import re
from transformers import DistilBertTokenizer
from transformers import DistilBertForSequenceClassification
import torch
import torch.nn as nn
from torch.utils.data import DataLoader, Dataset
from sklearn.model_selection import train_test_split
from torch.optim.lr_scheduler import StepLR
#from pandas.core.missing import find_valid_index

# Commented out IPython magic to ensure Python compatibility.
# %matplotlib inline
rand_seed = 42
np.random.seed(rand_seed)
torch.manual_seed(rand_seed)
plt.ion()

force_use_cpu = False
if torch.cuda.is_available() and not force_use_cpu:    
    print(f"CUDA device available: {torch.cuda.get_device_name()}")
    use_cuda = True
    device = "cuda"
else:
    print(f"CUDA not available or disabled, using CPU.")
    use_cuda = False
    device = "cpu"
    
#cpu_cores = multiprocessing.cpu_count() # logische CPUs
cpu_cores = psutil.cpu_count(logical=False)
print(f"Available CPU cores: {cpu_cores}")

!cp -r '/content/drive/MyDrive/Colab Notebooks' '/content'

data = pd.read_csv("/content/Colab Notebooks/train.csv")
labels = ['toxic', 'severe_toxic', 'obscene', 'threat','insult', 'identity_hate']
data.head()

test_data = pd.read_csv("/content/Colab Notebooks/test.csv")
test_data.head()

def clean_data (data, links=True,emojis=True,ip=True,css=True,html=True,dquotes=True,punct=True,schar=True,spaces=True,minimize_nontoxic=False):
    cleaned_data = data.copy()
    #print(clean_data)

    # Removing Hyperlinks from text beginning with http or https, followed by :// and one or more 
    # non-whitespace characters, beginning with www., followed by one or more non-whitespace characters. 
    if links:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"https?://\S+|www\.\S+","",x) )

    # Removing emojis from text
    if emojis:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub("["
                                                                                      u"\U0001F600-\U0001F64F"
                                                                                      u"\U0001F300-\U0001F5FF"  
                                                                                      u"\U0001F680-\U0001F6FF" 
                                                                                      u"\U0001F1E0-\U0001F1FF"  
                                                                                      u"\U00002702-\U000027B0"
                                                                                      u"\U000024C2-\U0001F251"
                                                                                      "]+","", x, flags=re.UNICODE))

    # Removing IP addresses from text 
    if ip:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}","",x))


    # matches of css style,class elements and attributes
    if css:
        idxs_css = []
        for i in  range(len(cleaned_data)):
            if re.findall(r"[{][|].+\n",cleaned_data.loc[i,"comment_text"]):
                idxs_css.append(i)        
        cleaned_data.drop(idxs_css,inplace=True)

    # Removing html tags from text 
    if html:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"<.*?>","",x))

    # Removing double quotes ""...""
    if dquotes:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"\"\"", "\"",x))   # replacing "" with "
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"^\"", "",x))      # removing quotation from start and the end of the string
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"\"$", "",x))

    # Removing Punctuation / Special characters (;:'".?@!%&*+) which appears more than twice in the text 
    if punct:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"[^a-zA-Z0-9\s][^a-zA-Z0-9\s]+", " ",x))

    # Removing Special characters 
    if schar:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"[^a-zA-Z0-9\s\"\',:;?!.()]", " ",x))

    # Removing extra spaces in text
    if spaces:
        cleaned_data["comment_text"] = cleaned_data["comment_text"].map(lambda x: re.sub(r"\s\s+", " ",x))
  
    cleaned_data.reset_index(inplace=True)
    cleaned_data.drop(columns=["index"], inplace=True)
    
    # Keeping 15291 comments from non_toxic comments and dropping the rest
    if minimize_nontoxic:
        C_indexs = cleaned_data[cleaned_data["total_classes"]==0].index
        drop_indxs = np.random.choice(C_indexs, size=127696, replace=False)
        # Randomly selecting and dropping non_toxic comments from datasets and leaving 5000 behind
        cleaned_data.drop(drop_indxs, inplace=True)
    cleaned_data.reset_index(inplace=True,drop = True)  
    return cleaned_data

data["total_classes"] = data.iloc[:,2:8].apply(lambda x: sum(x), axis=1)
data.head()

final_data = clean_data(data, minimize_nontoxic=True)
final_data.head()

#Daten in Trainingsdaten und Valitation daten aufspalten (statified)
X_train, X_val, Y_train, Y_val = train_test_split(final_data.iloc[:,1:2], final_data.iloc[:,2:], test_size=0.4, stratify=final_data.iloc[:,8])

X_train.reset_index(inplace=True, drop=True)
X_val.reset_index(inplace=True, drop=True)
Y_train.drop(columns=['total_classes'], inplace=True)
Y_train.reset_index(inplace=True, drop=True)
Y_val.drop(columns=['total_classes'], inplace=True)
Y_val.reset_index(inplace=True, drop=True)

#Dataset 

class Toxic_DataSet(torch.utils.data.Dataset):
    def __init__(self, x_data, y_data, *args, **kwargs):
        super().__init__()
        self.tokenizer = DistilBertTokenizer.from_pretrained("distilbert-base-uncased")
        self.comments = x_data
        self.comments["comment_text"] = self.comments["comment_text"].map(lambda x: self.tokenizer(x, padding="max_length", truncation=True, return_tensors="pt"))

        self.labels = y_data

    def __getitem__(self, index):
        x = self.comments['comment_text'][index]
        y = torch.Tensor(self.labels.loc[index,:])
        return x, y
    
    def __len__(self):
        return len(self.labels)

#create Dataset
Train_Dataset = Toxic_DataSet(X_train, Y_train)
Val_Dataset = Toxic_DataSet(X_val, Y_val)

print(len(Train_Dataset))

#create DataLoader
Train_Loader = DataLoader(Train_Dataset, batch_size=12, shuffle=True)
Val_Loader = DataLoader(Val_Dataset, batch_size=12, shuffle=True)

next(iter(Train_Loader))

'''
small_dataset_size = 100
Train_Dataset_small, _ = torch.utils.data.random_split(Train_Dataset, lengths=[small_dataset_size,len(Train_Dataset)-small_dataset_size])
Val_Dataset_small, _ = torch.utils.data.random_split(Val_Dataset, lengths=[small_dataset_size,len(Val_Dataset)-small_dataset_size])
Train_Loader_small = DataLoader(Train_Dataset_small, batch_size=12, shuffle=True)
Val_Loader_small = DataLoader(Val_Dataset_small, batch_size=12, shuffle=True)   
'''

#Vortrainiertes Model
model = DistilBertForSequenceClassification.from_pretrained("distilbert-base-uncased", num_labels=6)
#Modifikation des letzten 'Classifier' Level
'''
model.classidier = nn.Sequential(
    nn.Linear(768,7),
    nn.Sigmoid(),
)
'''
model

# Commented out IPython magic to ensure Python compatibility.
def build_training_system(model, optimizer, loss_func, lr_scheduler, train_loader, val_loader, device = None, verbose = True, **kwargs):
    """
    Builds a training system displaying metrics dynamically to view the progress.
    
    Parameters
    ----------
    model        : torch.nn.Module
    optimizer    : torch.optim.Optimizer
    loss_func    : torch.nn.Module
    lr_scheduler : torch.optim.lr_scheduler
    train_loader : torch.utils.data.DataLoader
    val_loader   : torch.utils.data.DataLoader
    device       : str
    """
    import torch
    import time
    import ignite
    import ignite.contrib.handlers
    import seaborn
    import numpy as np
    from ignite.engine import Events
    import matplotlib.pyplot as plt
#     %matplotlib notebook
    seaborn.set(rc = {"figure.figsize" : (6, 4)})
    
    class ModelWrapper(torch.nn.Module):
        def forward(self, x):
            return model(x[0], x[1])
    wrapper = ModelWrapper()
    
    def prepare_batch(batch):
        x, y = batch
        mask = x['attention_mask'].squeeze(1)
        input_id = x["input_ids"].squeeze(1)
        if device:
            mask = mask.to(device, non_blocking = True)
            input_id = input_id.to(device, non_blocking = True)
            y = y.to(device, non_blocking = True)
            model.to(device, non_blocking = True)
        return input_id, mask, y

    def train_step(engine, batch):
        model.train()
        optimizer.zero_grad()
        input_id, mask, y = prepare_batch(batch)
        y_pred = wrapper((input_id, mask))
        y_pred = F.relu(y_pred.logits, inplace=True)
        y_pred = torch.round(y_pred)
        loss = loss_func(y_pred, y)
        loss.backward()
        optimizer.step()
        lr_scheduler.step()
        return y_pred, y
    
    def evaluate_step(engine, batch):
        model.eval()
        with torch.no_grad():
            input_id, mask, y = prepare_batch(batch)
            y_pred = model(input_id, mask)
            y_pred = F.relu(y_pred.logits, inplace=True)
            y_pred = torch.round(y_pred)
        return y_pred, y

    def on_create_data(engine):
        self = engine.state
        columns = ["train_loss", "val_loss", "train_accuracy", "val_accuracy"]
        self.data = pd.DataFrame(np.nan, index = list(range(1, self.max_epochs + 1)), columns = columns)
        self.index = 1

    def on_evaluate_model(engine):
        self = engine.state
        self.evaluator.run(val_loader)
        self.data.at[self.index, "val_loss"] = self.evaluator.state.metrics["loss"]
        self.data.at[self.index, "val_accuracy"] = self.evaluator.state.metrics["accuracy"]
        self.data.at[self.index, "train_loss"] = self.metrics["train_loss"]
        self.data.at[self.index, "train_accuracy"] = self.metrics["train_accuracy"]
        self.index += 1

    def on_create_progressbar(engine):
        self = engine.state
        self.tqdm_logger = ignite.contrib.handlers.ProgressBar(persist = False)
        self.tqdm_logger.attach(engine)
    
    def on_create_timer(engine):
        self = engine.state
        self.start_time = time.time()
        
    def on_delete_timer(engine):
        self = engine.state
        elapsed_time = time.time() - self.start_time
        elapsed_time = time.strftime("%H hours %M minutes %S seconds", time.gmtime(elapsed_time))
        print(f"Finished in {elapsed_time}.")
    
    def on_output_metrics(engine):
        self = engine.state
        print(self.data)
    
    def on_create_graphics(engine):
        self = engine.state
        plt.ion()
        fig, (ax1, ax2) = plt.subplots(1, 2, figsize = (8, 4))
        fig.suptitle("Loss and Accuracy during training")
        self.figure = fig
        self.loss_axis = ax1
        self.acc_axis = ax2

    def on_update_graphics_epoch(engine):
        self = engine.state
        xs = list(range(1, self.max_epochs + 1))
        xlim = [0, self.max_epochs + 1]
        self.acc_axis.cla()
        self.acc_axis.plot(xs, self.data["train_accuracy"], label = "train accuracy", linestyle='--', marker='o')
        self.acc_axis.plot(xs, self.data["val_accuracy"], label = "validation accuracy", linestyle='--', marker='o')
        self.acc_axis.set_xlabel("epochs")
        self.acc_axis.set_ylabel("accuracy")
        self.acc_axis.set_xlim(xlim)
        self.acc_axis.legend()
        self.loss_axis.cla()
        self.loss_axis.plot(xs, self.data["train_loss"], label = "train loss", linestyle='--', marker='o')
        self.loss_axis.plot(xs, self.data["val_loss"], label = "validation loss", linestyle='--', marker='o')
        self.loss_axis.set_xlabel("epochs")
        self.loss_axis.set_ylabel("loss")
        self.loss_axis.set_xlim(xlim)
        self.loss_axis.legend()
        self.figure.tight_layout()
        self.figure.canvas.draw()

    # create the trainer object
    engine = ignite.engine.Engine(train_step)
    
    # we want to display the metrics
    self = engine.state

    # we only use loss and accuracy
    metrics = {
        "loss": ignite.metrics.Loss(loss_func),
        "accuracy": ignite.metrics.Accuracy()
    }
    
    # implementation of some specialized Engine class for supervised learning
    self.evaluator = ignite.engine.Engine(evaluate_step)
    
    for name, metric in metrics.items():
        metric.attach(self.evaluator, name)

    # automatic calculation for the training metrics
    accuracy_metric = ignite.metrics.Accuracy()
    accuracy_metric.attach(engine, "train_accuracy")
    loss_metric = ignite.metrics.Loss(loss_func)
    loss_metric.attach(engine, "train_loss")

    if not verbose:
        return engine
    
    # manually attach event listeners (makes it easier to reorder or comment out)
    engine.add_event_handler(Events.STARTED, on_create_data)
    engine.add_event_handler(Events.EPOCH_COMPLETED, on_evaluate_model)
    engine.add_event_handler(Events.STARTED, on_create_progressbar)
    engine.add_event_handler(Events.STARTED, on_create_timer)
    engine.add_event_handler(Events.STARTED, on_create_graphics)
    engine.add_event_handler(Events.EPOCH_COMPLETED, on_update_graphics_epoch)
    '''
    if "num_classes" in kwargs:
        confusion_metric = ignite.metrics.confusion_matrix.ConfusionMatrix(kwargs["num_classes"], average = "precision")
        confusion_metric.attach(engine, "confusion_matrix")
        def on_render_confusion_matrix(engine):
            self = engine.state
            plt.figure(figsize = (8, 8))
            ax = plt.axes()
            ax.set_title("Confusion Matrix")
            seaborn.heatmap(self.metrics["confusion_matrix"], annot = True)
            plt.show()
        engine.add_event_handler(Events.COMPLETED, on_render_confusion_matrix)
    '''
    engine.add_event_handler(Events.COMPLETED, on_output_metrics)
    engine.add_event_handler(Events.COMPLETED, on_delete_timer)
    return engine

optimizer = torch.optim.Adam(model.parameters(), lr = 0.0003)
loss_func = nn.BCELoss()
lr_scheduler = StepLR(optimizer, step_size=212, gamma=0.1)
trainer = build_training_system(model, optimizer, loss_func, lr_scheduler, Train_Loader, Val_Loader, device)

_ = trainer.run(Train_Loader, max_epochs = 5)